/* --------------------------------------------------------------  */
/* (C)Copyright 2007,2008,                                         */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
// @(#) internal-src/lib/dacs/cell/include/dacs_ppu_process.h v1.7 - 9/16/08 09:55:47

#ifndef _DACS_PPU_PROCESS_H_
#define _DACS_PPU_PROCESS_H_

#include <dacs.h>
#include    <libspe2.h>

//
//  C++ interface
//
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

// This is a check that the DaCS program handle is large enough to accomodate
// the libspe program handle.  
char sanity_check[sizeof(dacs_program_handle_t) > sizeof(spe_program_handle_t) ?
0: -1];

//  --------------------------------------------------------------------
//
//
// --------------------------------------------------------------------
extern  DACS_ERR_T dacs_ppu_de_start (  de_id_t  ae,
                                        void * text,
                                        char const ** argv,
                                        char const ** env,
                                        DACS_PROC_CREATION_FLAG_T creation_flags,
                                        dacs_process_id_t *ppid);


//  --------------------------------------------------------------------
//
//
// --------------------------------------------------------------------
extern  DACS_ERR_T  dacs_ppu_num_processes_supported (  de_id_t ae,
                                                        uint32_t *num_processes );

//  --------------------------------------------------------------------
//
//
// --------------------------------------------------------------------
extern  DACS_ERR_T  dacs_ppu_num_processes_running (    de_id_t ae,
                                                    uint32_t *num_processes );

//  --------------------------------------------------------------------
//
//
// --------------------------------------------------------------------
extern  DACS_ERR_T dacs_ppu_de_test (   de_id_t ae,
                                        dacs_process_id_t process_id,
                                        int4 *);


//  --------------------------------------------------------------------
//
//
// --------------------------------------------------------------------
extern  DACS_ERR_T dacs_ppu_de_wait (   de_id_t ae,
                                        dacs_process_id_t process_id,
                                        int4 *);


//  --------------------------------------------------------------------
//
//
// --------------------------------------------------------------------
extern  DACS_ERR_T dacs_ppu_de_kill (   de_id_t ae,
                                        dacs_process_id_t process_id,
                                        DACS_KILL_TYPE_T kill_type);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _DACS_PPU_PROCESS_H_  */
