/* --------------------------------------------------------------  */
/* (C)Copyright 2007,2008,                                         */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */

// ident = "@(#) internal-src/lib/dacs/cell/include/dacs_ppu_send_recv.h v1.11 - 9/16/08 09:55:47 @(#)"

#ifndef _DACS_PPU_SEND_RECV_H_
#define _DACS_PPU_SEND_RECV_H_

#include <dacs.h>
#include <dacs_ppe_internal.h>

//
//  C++ interface
//
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

extern DACS_ERR_T 
dacspi_send_recv(void *, uint32_t, de_id_t, dacs_process_id_t, uint32_t, 
                 dacs_wid_t, DACS_BYTE_SWAP_T, dacsi_msg_type_t);

static inline DACS_ERR_T 
dacs_ppu_send (void *src_data, uint32_t len, de_id_t dst_de, 
               dacs_process_id_t dst_pid, uint32_t stream, dacs_wid_t wid, 
               DACS_BYTE_SWAP_T swap)
{
    return dacspi_send_recv(src_data, len, dst_de, dst_pid, stream, wid, swap,
                            DACSI_MSG_SEND);
}

static inline DACS_ERR_T 
dacs_ppu_recv (void *dst_data, uint32_t len, de_id_t src_de, 
               dacs_process_id_t src_pid, uint32_t stream, dacs_wid_t wid, 
               DACS_BYTE_SWAP_T swap)
{
    return dacspi_send_recv(dst_data, len, src_de, src_pid, stream, wid, swap,
                            DACSI_MSG_RECV);
}

//
//  C++ interface
//
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _DACS_PPU_SEND_RECV_H_    */
